#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################
# Part of the E-Blah Core                   #
#############################################

require("$language/Load.lng");

# Quick errors for restricted areas
sub is_admin  {
	error("$ltxt[1]-admin-",1) if(!$members{'Administrator',$username});
	if($sessionEnabled) {
		CoreLoad('AdminList');
		VerifyAdmin();
	}
}

sub is_mod    {
	error($ltxt[2]) if(!$members{'Administrator',$username} && !$ismod);
	if($sessionEnabled) {
		CoreLoad('AdminList');
		VerifyAdmin();
	}
}

sub is_member {
	if($username eq 'Guest') { error($gtxt{'noguest'}.'-register-'); } # Moved to is_member() for uniformity
	if(!$memberid{$username}{'status'}) { return(); }
	elsif($memberid{$username}{'status'} eq 'ADMIN') { error("$ltxt[24] $ltxt[26]"); }
	elsif($memberid{$username}{'status'} eq 'EMAIL') { error("$ltxt[24] $ltxt[25]"); }
	elsif($memberid{$username}{'status'} eq 'EMAIL|ADMIN') { error("$ltxt[24] $ltxt[27]"); }
		else { error($ltxt[23]); }
}

sub BoardCheck {
	my($bfnd,$nump,$t,$sqlcat,$sqlboards);

	CoreLoad('categories',2);
	if(!$delcache) {
		$sqlcat = SQL->new('categories','id');
		$sqlcat->limit();
		%cats = $sqlcat->select();
		@catbase = $sqlcat->col_array();
		$sqlcat = Cache->new();
		$sqlcat->hash('cats',%cats);
		$sqlcat->array('catbase',@catbase);
		$sqlcat->save('categories',120);
	}

	CoreLoad('boards',2);
	if(!$delcache) {
		$sqlboards = SQL->new('boards','id');
		$sqlboards->limit();
		%boards = $sqlboards->select();
		@boardbase = $sqlboards->col_array();
		$sqlboards = Cache->new();
		$sqlboards->hash('boards',%boards);
		$sqlboards->array('boardbase',@boardbase);
		$sqlboards->save('boards',120);
	}

	foreach(@boardbase) {
		$parents{$boards{$_}{'parent'}} .= $_.',';
	}
	
	foreach(@catbase) {
		$parents{$cats{$_}{'parent'}} .= '('.$_.'),';
	}

	if($URL{'b'} eq '' && $URL{'m'} ne 'latest' && ($URL{'v'} eq '' || $URL{'v'} eq 'print') && $URL{'m'} ne '') {
		$sqlboards = SQL->new('topics','id');
		$sqlboards->where('id');
		%message = $sqlboards->select($URL{'m'});

		$URL{'b'} = $message{$URL{'m'}}{'boardid'};

		$scripturl = "$scriptname$modrewrite\lb-$URL{'b'}$usert";
		$activeusers = '';
	}

	return() if($URL{'b'} eq '');

	error($ltxt[5],0,1) if($boards{$URL{'b'}} eq '');

	if($boards{$URL{'b'}}{'redirect'} ne '') { # This board redirects, increase hits and exit
		$boards{$URL{'b'}}{'hits'} += 1;
		$sqlboards = SQL->new('boards');
		$sqlboards->set('hits');
		$sqlboards->where('id');
		$sqlboards->update($boards{$URL{'b'}}{'hits'},$URL{'b'});

		$boards{$URL{'b'}}{'redirect'} =~ s/&#47;/\//g;
		redirect($boards{$URL{'b'}}{'redirect'});
	}

	# Lets start applying board permissions ...
	@mods = split(/\|/,$boards{$URL{'b'}}{'moderators'});
	foreach (@mods) {
		if($_ =~ /\((.+?)\)/ && $members{$1,$username}) { $ismod = 1; } # Member Group Mods
		if($username eq $_) { $ismod = 1; last; }
	}

	$catid = $boards{$URL{'b'}}{'parent'};
	$catname = $cats{$catid}{'name'};

	push(@mgaccess,(split(',',$boards{$URL{'b'}}{'access_perm'}),split(',',$cats{$catid}{'permissions'})));
	if(!GetMemberAccess($cats{$catid}{'permissions'}) || !GetMemberAccess($boards{$URL{'b'}}{'access_perm'})) { error($ltxt[5]); }

	if($boards{$URL{'b'}}{'password'} ne '') { CoreLoad('BoardLock'); Password(); }
	if($boards{$URL{'b'}}{'voting'}) { $allowrate = 1; }

	$boardnm = $boards{$URL{'b'}}{'name'};
}

sub GetMessageDatabase {
	my($findmessage,$newboard,$savedb) = @_;
	my($t,$boardid,$id,$returnid,$foundid,@newlist);

	if($savedb eq '') {
		fopen(MESSDB,"$boards/Messages.db");
		while($t = <MESSDB>) {
			chomp $t;
			($id,$boardid) = split(/\|/,$t);
			if($id == $findmessage) { $returnid = $boardid; last; }
		}
		fclose(MESSDB);
		return($returnid);
	} else {
		fopen(MESSDB,"+<$boards/Messages.db",1);
		while($t = <MESSDB>) {
			chomp $t;
			($id,$boardid) = split(/\|/,$t);
			if($id eq $findmessage && $savedb != 2) { push(@newlist,"$id|$newboard"); $foundid = 1; next; } # Change board
			elsif($id eq $findmessage && $savedb == 2) { $foundid = 1; next; } # Delete
			push(@newlist,$t);
		}
		truncate(MESSDB,0);
		seek(MESSDB,0,0);
		if(!$foundid) { print MESSDB "$findmessage|$newboard\n"; } # New message
		foreach $t (@newlist) { print MESSDB "$t\n"; }
		fclose(MESSDB);
	}
}

sub Mods {
	my($colors);
	$modz = '';
	foreach(@mods) {
		if($_ =~ /\((.+?)\)/ && $permissions{$1}{'name'} ne '') {
			if($permissions{$1}{'color'} ne '') { $colors = qq~ class="usercolors" style="color: $permissions{$1}{'color'}"~; }
			$modz .= qq~<a href="$surl\lv-members/a-groups/group-$1/"$colors>$permissions{$1}{'name'}</a>, ~;
		}
			else {
				GetMemberID($_);
				if($memberid{$_}{'sn'} eq '') { next; }
				$modz .= "$userurl{$_}, ";
			}
	}
	if($modz eq '') { return(); }
	$modz =~ s/, \Z//gi;
}

sub StarCreator {
	my($starr);
	my($input) = @_;
	if($permissions{$input}{'starcount'} < 1 || $permissions{$input}{'starcount'} > 51) { $permissions{$input}{'starcount'} = 1; }
	if($permissions{$input}{'star'} eq '') { return(); }
	for($g = 0; $g < $permissions{$input}{'starcount'}; $g++) { $starr .= qq~<img src="$images/$permissions{$input}{'star'}" alt="" />~; }
	return($starr);
}

sub UserMiniProfile { # Name, Mini-profile, Guest (t/f)
	my($user,$quickprofile) = @_;
	my($membername,$profile,$width,$height,$pic,$gen,$color);

	# Get the list of profile options (change order to change order of occurance)
	@profilelist = ('posts','gender','ppd','reputation','score','timeon','location','age');

	GetMemberID($user);
	if($memberid{$user}{'sn'} eq '') {
		$tempuser = FindOldMemberName($user);
		$tempprof = qq~<div style="padding: 10px" class="center">$gtxt{'0'}</div>~;
		return(1);
	}
	
	$lastactive{$user} = get_date($memberid{$user}{'lastactive'});

	# Get the group apart of, and stars ...
	$permissions{$membergrp{$user}}{'level'} = $permissions{$membergrp{$user}}{'level'} <= 0 ? ($permissions{'Moderators'}{'level'}+1) : $permissions{$membergrp{$user}}{'level'};
	foreach(@mods) {
		if($permissions{'Moderators'}{'level'} && $user eq $_ && $permissions{$membergrp{$user}}{'level'} >= $permissions{'Moderators'}{'level'}) {
			$membergrp{$user} = 'Moderators';
			last;
		}
	}

	if($membergrp{$user} ne '') {
		$stat{$user} = $permissions{$membergrp{$user}}{'name'};
		$stat{$user} = CensorList($memberid{$user}{'personaltxt'}) if($permissions{$membergrp{$user}}{'coverup'} ne '' && $memberid{$user}{'personaltxt'});

		$stat{$user} = "<strong>$stat{$user}</strong>" if($permissions{$membergrp{$user}}{'team'});
		$stat{$user} = CensorList($memberid{$user}{'personaltxt'}).'<br />'.$stat{$user} if($memberid{$user}{'personaltxt'} ne '' && !$permissions{$membergrp{$user}}{'coverup'});

		$star{$user} = StarCreator($membergrp{$user}) if($permissions{$membergrp{$user}}{'star'});
	}
	
	# Avatar
	if(!$memberid{$username}{'ownavatar'} && $memberid{$user}{'avatar'} ne '' && $apic) {
		if($memberid{$user}{'avatarsize'}) { ($height,$width) = split(/\|/,$memberid{$user}{'avatarsize'}); }
			else { $width = $picwidth; $height = $picheight; }
		if($memberid{$user}{'avatar'} =~ /http:/) { $avatar{$user} = qq~<img src="$memberid{$user}{'avatar'}" width="$width" height="$height" alt="" /><br />~; }
			elsif($memberid{$user}{'avatarupload'}) {
				$memberid{$user}{'avatar'} =~ s/\A$uploadurl//;
				$avatar{$user} = qq~<img src="$uploadurl/$memberid{$user}{'avatar'}" width="$width" height="$height" alt="" /><br />~;
			}
			else { $avatar{$user} = qq~<img src="$avsurl/$memberid{$user}{'avatar'}" alt="" /><br />~; }
	}

	# E-mail address
	$email{$user} = $memberid{$user}{'hidemail'} && $hmail && !$members{'Administrator',$username} ? '' : qq~<a href="mailto:$memberid{$user}{'email'}">$Pimg{'email'}</a>$Pmsp2~;

	# Post count
	if(!$hideposts) { $posts{$user} = MakeComma($memberid{$user}{'posts'}); }

	# Instant Messanging
	if($memberid{$user}{'aim'} ne '')   { $aim{$user} = qq~$Pmsp2<a href="aim:goim?screenname=$memberid{$user}{'aim'}&amp;message=You+there?" title="$ltxt[10] ($memberid{$user}{'aim'})">$Pimg{'aim'}</a>~; }
	if($memberid{$user}{'msn'} ne '')   { $msn{$user} = qq~$Pmsp2<a href="http://members.msn.com/$memberid{$user}{'msn'}" onclick="target='msn';" title="$memberid{$user}{'msn'}">$Pimg{'msn'}</a>~; }
	if($memberid{$user}{'icq'} ne '')   { $icq{$user} = qq~$Pmsp2<a href="http://www.icq.com/whitepages/wwp.php?to=$memberid{$user}{'icq'}"$blanktarget title="$memberid{$user}{'icq'}">$Pimg{'icq'}</a>~; }
	if($memberid{$user}{'yim'} ne '')   { $yim{$user} = qq~$Pmsp2<a href="http://profiles.yahoo.com/$memberid{$user}{'yim'}" onclick="target='yim';" title="$memberid{$user}{'yim'}">$Pimg{'yim'}</a>~; }
	if($memberid{$user}{'skype'} ne '') { $skype{$user} = qq~$Pmsp2<a href="skype:$memberid{$user}{'skype'}" onclick="target='skype';" title="$memberid{$user}{'skype'}">$Pimg{'skype'}</a>~; }

	# Signature
	if(!$memberid{$username}{'showsig'} && $maxsig > 0 && $memberid{$user}{'sig'}) {
		$signature{$user} = qq~<tr><td><br /><br /></td></tr><tr><td class="postbody" style="vertical-align: bottom"><div class="messageseps smalltext">~.BC($memberid{$user}{'sig'})."</div></td></tr>";
	}

	# Gender
	if($showgender) {
		if($memberid{$user}{'sex'} == 1) { $pic = 'male'; $gen = $ltxt[11]; }
		elsif($memberid{$user}{'sex'} == 2) { $pic = 'female'; $gen = $ltxt[12]; }

		$gender{$user} = qq~<img src="$images/$pic.gif" alt="" /> $gen~ if($pic && $gen);
	}

	# Posts Per Day
	if($sppd) {
		($t,$t,$t,$lday,$lmonth,$lyear,$lweek) = localtime($memberid{$user}{'registered'});
		($t,$t,$t,$cday,$cmonth,$cyear,$cweek) = localtime(time);
		$lyear = substr($lyear,-2);
		$cyear = substr($cyear,-2);
		++$lmonth; ++$cmonth;
		$reg = (365*$lyear)+(30.42*$lmonth)+$lday;
		$now = (365*$cyear)+(30.42*$cmonth)+$cday;
		$days = ($now-$reg) || 1;
		$ppd{$user} = sprintf("%.2f", $memberid{$user}{'posts'}/$days);
	}

	# Reputation
	if($enablerep) {
		if($memberid{$user}{'reputation'} ne '' && $memberid{$user}{'reputation'} > 0) {
			$memberrep = sprintf("%.2f",(($memberid{$user}{'prep'}/$memberid{$user}{'reputation'})*100));

			if($memberrep < 50) { $color = 'redrep'; } # Horrible
			elsif($memberrep > 75) { $color = 'greenrep'; } # Best
				else { $color = 'grayrep'; } # Neut

			$reputation{$user} = qq~<span class="$color">$memberrep%</span>~ if(!$repscore || $repscore == 1);
			$memberid{$user}{'prep'} = 0 if(!$memberid{$user}{'prep'});
			$memberid{$user}{'nrep'} = 0 if(!$memberid{$user}{'nrep'});
			$score{$user} = qq~<span class="greenrep">+$memberid{$user}{'prep'}</span> / <span class="redrep">-$memberid{$user}{'nrep'}</span>~ if($repscore && ($memberid{$user}{'prep'} || $memberid{$user}{'nrep'}));
		}
	}

	# User logged in time
	($t1,$t2) = split(/\|/,$memberid{$user}{'rndsid'});
	if($showloggedon && ($t1 > 60)) {
		$days  = int($t1/86400);
		$hours = int($t1/3600)-($days*24);
		$mins  = int($t1/60)-(($hours+($days*24))*60);

		$days  = $days  ? " $days $ltxt[43]"   : '';
		$hours = $hours ? " $hours $gtxt{'3'}" : '';
		$mins  = $mins  ? " $mins $gtxt{'2'}"  : '';

		$timeon{$user} = qq~$days$hours$mins~;
	}

	if($showage && $memberid{$user}{'dob'} ne '') { $age{$user} = calage($memberid{$user}{'dob'}); }

	# Admin Text
	$admintext{$user} = $memberid{$user}{'admintxt'}.'<br />' if $memberid{$user}{'admintxt'} ne '';

	# Location
	$location{$user} = $showlocation && $memberid{$user}{'location'} ne '' ? $memberid{$user}{'location'} : '';

	$instmsg{$user} = "$icq{$user}$aim{$user}$yim{$user}$msn{$user}$skype{$user}";
	
	$profile{$user} = <<"EOT";
<div class="avatarprofile">$avatar{$user}$stat{$user}<br />$admintext{$user}$star{$user}</div>
EOT

	if($quickprofile ne 'quick') {
		foreach(@profilelist) {
			if(${$_}{$user} eq '') { next; }
			if($fancyqprofile) {
				$profile{$user} .= <<"EOT";
<div class="win fancyprofilet"><strong>$miniprofile{$_}</strong></div>
<div class="win2 fancyprofilev">${$_}{$user}</div>
EOT
			} else {
				$profile{$user} .= <<"EOT";
<div class="plainprofile"><strong>$miniprofile{$_}:</strong> ${$_}{$user}</div>
EOT
			}
		}
	}

	return(0); # 0 = not guest
}

sub LogPage {
	return() if($username eq 'Guest');
	my($lid,$ltime,$found,$lltime,$tempwrite,%found,$sqlstate);

	$lltime = (time+2); # +2 prevents "Your New Post == New".

	$sqlstate = SQL->new('memberlog','board');
	$sqlstate->where('userid');
	$sqlstate->columns('board','visited');
	$sqlstate->limit();
	%logged = $sqlstate->select($username);

	# Delete all old data ... =)
	if($memberid{$username}{'lastvisit'} && $logged{'AllBoards'}{'visited'} < $memberid{$username}{'lastvisit'}) {
		$sqlstate = SQL->new('memberlog');
		$sqlstate->where('userid');
		$sqlstate->delete($username);
		$sqlstate->into('userid','board','visited');
		$sqlstate->insert($username,"AllBoards",$memberid{$username}{'lastvisit'});
	}

	if($URL{'m'} ne '') {
		$sqlstate = SQL->new('memberlog');
		if(!$logged{"m$URL{'m'}"}{'visited'}) {
			$sqlstate->into('userid','board','visited');
			$sqlstate->insert($username,"m$URL{'m'}",$lltime);
		} else {
			$sqlstate->set('visited');
			$sqlstate->where('userid','board');
			$sqlstate->update($lltime,$username,"m$URL{'m'}");
		}
	}

	$sqlstate = SQL->new('memberlog');
	if(!$logged{$URL{'b'}}{'visited'}) {
		$sqlstate->into('userid','board','visited');
		$sqlstate->insert($username,$URL{'b'},$lltime);
	} else {
		$sqlstate->set('visited');
		$sqlstate->where('userid','board');
		$sqlstate->update($lltime,$username,$URL{'b'});
	}
}

sub LMGS {
	if($members{'Administrator',$username}) { return(); }
	foreach(@fullgroups) {
		if($members{$_,$username}) {
			$ipon     = $permissions{$_}{'ip'} || $ipon;
			$modon    = $permissions{$_}{'moderate'} || $modon;
			$ston     = $permissions{$_}{'sticky'} || $ston;
			$modifyon = $permissions{$_}{'modify'} || $modifyon;
			$proon    = $permissions{$_}{'profile'} || $proon;
			$calmod   = $permissions{$_}{'cal'} || $calmod;
		}
	}
}

sub Ban {
	my($sql,%banlist);

	$sql = SQL->new('banlist','user');
	$sql->where('user|LIKE|OR','user||OR','user');
	%banlist = $sql->select("%$ENV{'REMOTE_ADDR'}%",$memberid{$username}{'email'},$username);

	foreach($sql->col_array) {
		CoreLoad('BoardLock');
		Banned($banlist{$_}{'timelimit'},$banlist{$_}{'dateadded'},$banlist{$_}{'id'});
	}
}

sub Format {
	($temp) = $_[0];
	$temp =~ s/&/\&amp;/g;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	$temp =~ s/\cM//g;
	$temp =~ s/\n/<br \/>/g;
	$temp =~ s/\|/\&#124;/g;
	$temp =~ s/"/\&quot;/g;
	$temp =~ s/  /&nbsp;&nbsp;/gi;
	$temp =~ s/\t/&nbsp; &nbsp; &nbsp;/gi;
	return $temp;
}

sub Unformat {
	($temp) = $_[0];
	$temp =~ s/<br \/>/\n/g;
	$temp =~ s/<br>/\n/g;     # Temporary
	$temp =~ s/&lt;/</g;
	$temp =~ s/&gt;/>/g;
	$temp =~ s/&nbsp; &nbsp; &nbsp;/\t/g; # DO THE TABS
	$temp =~ s/&nbsp;&nbsp;/  /gi;
	return $temp;
}

sub BoardProperties {
	$tallow = $repallow = 0;

	if(!($noguestp == 0 && $username eq 'Guest') && GetMemberAccess($boards{$URL{'b'}}{'start_perm'})) { $tallow = 1; }
	if(!($noguestp == 0 && $username eq 'Guest') && GetMemberAccess($boards{$URL{'b'}}{'reply_perm'})) { $repallow = 1; }
}

sub ListBoards {
	if(!$boardbase[1]) { return(qq~<span class="smalltext">$boardnm ($ltxt[19])</span>~); }

	foreach(@catbase) {
		($t,$boardid,$memgrps,$t,$t,$subcats) = split(/\|/,$_);
		$catbase{$boardid} = $_;
		if(!GetMemberAccess($memgrps)) { next; }
		foreach(split(/\//,$subcats)) { $noshow{$_} = 1; }

		$cats .= "$boardid/";
	}

	foreach(@boardbase) {
		($id,$t,$t,$t,$t,$t,$t,$passed,$t,$t,$boardgood,$t,$t,$redir) = split("/",$_);
		if(!$members{'Administrator',$username} && (!GetMemberAccess($boardgood) || $passed ne '' || $redir ne '')) { next; }
		$board{$id} = $_;
	}

	$temp = <<"EOT";
<script type="text/javascript">
<!--
function JumpTo(ghere) {
 if(ghere != '') { location = "$surl\lb-"+ghere+"/"; }
}
//-->
</script>
<select name="JumpZ" onchange="JumpTo(this.value);">
EOT

	$scat{"$URL{'b'}"} = ' selected="selected"';
	SubCatsList(0);
	return($temp."</select>");
}

sub SubCatsList {
	my($parent,$spacing,$noshow) = @_;
	$parent = 0 if($parent eq '');

	foreach(split(',',$parents{$parent})) {
		if($_ =~ /\((.*?)\)/) {
			next if(!GetMemberAccess($cats{$1}{'permissions'}) && !$noshow);
			$temp .= qq~<optgroup label="$spacing$cats{$1}{'name'}">~;
			SubCatsList($1,"$spacing&nbsp; &nbsp; ",$noshow);
			$temp .= "</optgroup>";
		} else {
			next if(!GetMemberAccess($boards{$_}{'access_perm'}) && !$noshow);
			next if($noshow ne '' && $noshow eq $_);
			$grood = 1 if($noshow ne '');
			$temp .= qq~<option value="$_"$scat{$_}>$spacing$boards{$_}{'name'}</option>~;
		}
	}
}

sub FindStatus {
	my($temp);

	if($type) { $temp = 'locked'; }
	elsif($replies >= $vhtdmax) { $temp = 'veryhotthread'; }
	elsif($replies >= $htdmax) { $temp = 'hotthread'; }
		else { $temp = 'thread'; }
	if($poll && $type) { $temp = 'poll_lock'; }
	elsif($poll) { $temp = 'poll_icon'; }
	if($messages{$fmess}{'sticky'} && $type && $temp ne 'poll_icon') { $temp = 'sticky_lock'; }
	elsif($messages{$fmess}{'sticky'} && $temp eq 'poll_icon') { $temp = 'poll_sticky'; }
	elsif($messages{$fmess}{'sticky'}) { $temp = 'sticky'; }

	if(!$messages{$fmess}{'sticky'} && ($boards{$URL{'b'}}{'archived'} > 0 && time > $_[0]+(86400*$boards{$URL{'b'}}{'archived'}))) {
		$type = 1 if(!$members{'Administrator',$username});
		$temp = 'archive_lock';
	}

	return($temp);
}

sub CensorList {
	my($censor,$sql);
	if($memberid{$username}{'censor'}) { return($_[0]); }

	if(!$Censorlist) {
		CoreLoad('censor',2);
		if(!$delcache) {
			$sql = SQL->new('censorlist','id');
			$sql->limit();
			%censor = $sql->select();
		
			foreach($sql->col_array()) {
				$CensorValues .= lc($censor{$_}{'word'}).'|';
				$Censor{lc($censor{$_}{'word'})} = Unformat($censor{$_}{'replacement'});
				$Censor{lc($censor{$_}{'word'})} =~ s/\&quot;/"/g;
			}
			$CensorValues =~ s/\|\Z//g;
		
			$sql = Cache->new();
			$sql->hash('Censor',%Censor);
			$sql->variable('CensorValues',$CensorValues);
			$sql->save('censor',1440);
		}
		$Censorlist = 1;
	}

	$_[0] =~ s/\b($CensorValues)\b/$Censor{lc($1)}/gi;

	return($_[0]);
}

sub MakeSmall { # To make long code look like it's suppose to, do this ...
	if(!$BCLoad) { return; }
	$message =~ s/<(.[^">]*?)\Z//gsi;
	$message =~ s~\[(.[^\]]*?)\Z~~gsi;
	$message =~ s/<a href="(.[^">]*?)\Z//gsi;
	$message =~ s~\[code\](.*?)\Z~&Code~esgi;
	$message =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[s\](.*?)\Z~<s>$1</s>~gsi;
	$message =~ s~\[b\](.*?)\Z~<strong>$1</strong>~gsi;
	$message =~ s~\[i\](.*?)\Z~<i>$1</i>~gsi;
	$message =~ s~\[u\](.*?)\Z~<u>$1</u>~gsi;
	$message =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\Z~<span style="font-size: $1px">$2</span>~gsi;
	$message =~ s~\[pre\](.+?)\Z~<pre>$1</pre>~gsi;
	$message =~ s~\[justify\](.+?)\Z~<div style="text-align: justify">$1</div>~gsi;
	$message =~ s~\[left\](.+?)\Z~<div style="text-align: left">$1</div>~gsi;
	$message =~ s~\[right\](.+?)\Z~<div style="text-align: right">$1</div>~gsi;
	$message =~ s~\[center\](.+?)\Z~<div style="text-align: center">$1</div>~gsi;
	$message =~ s~\[face=(.+?)\](.+?)\Z~<span style="font-family: $1">$2</span>~gsi;
	$message =~ s~\[color=(.+?)\](.+?)\Z~<span style="color: $1">$2</span>~gsi;
	$message =~ s~\[sub\](.+?)\Z~<sub>$1</sub>~gsi;
	$message =~ s~\[sup\](.+?)\Z~<sup>$1</sup>~gsi;
	$message =~ s~\[img(.+?)\Z~~gsi;
	if($message =~ /\[list(.*?)\](.+?)\Z/) {
		$message =~ s~\[list\](.+?)\Z~<ul>$1</ul>~gsi;
		$message =~ s~\[list=([a-zA-Z|1]+?)\](.+?)\Z~<ol type="$1">$2</ol>~gsi;
		$message =~ s~\[\*\]~<li>~gsi;
	}
}

sub GetMemberAccess { # Adapted from the BoardIndex =P
	my($grpaccess,$accessuser) = @_;
	my $boot = 1;
	if($accessuser eq '') { $accessuser = $username; }
	foreach $group (split(',',$grpaccess)) {
		if($members{$group,$accessuser}) { $boot = 0; }
		$boot = 0 if(($group eq 'member' && !$lockuserout && $username ne 'Guest') || ($group eq 'guest' && $accessuser eq 'Guest') || ($group eq 'validating' && $lockuserout && $accessuser ne 'Guest'));
	}
	if($boot) { return(0); }
	return(1);
}

sub CreateGroups { # Member Groups (Version 2.1)
	my(%groupmembers,%group);

	CoreLoad('ranks',2);
	if(!$delcache) {
		$sql = SQL->new('ranks','id');
		$sql->limit();
		%permissions = $sql->select();
		@fullgroups = $sql->col_array();

		$cache = Cache->new();
		$cache->hash('permissions',%permissions);
		$cache->array('fullgroups',@fullgroups);
		$cache->save('ranks',15);
	}

	foreach(@fullgroups) {
		if($permissions{$_}{'pcount'} ne '') { push(@grpsposts,"$permissions{$_}{'pcount'}|$_"); }
			else {
				foreach $user (split(',',$permissions{$_}{'members'})) {
					$members{$_,$user} = 1;
					if($permissions{$_}{'level'} > 0 && ($permissions{$_}{'level'} < $permissions{$membergrp{$user}}{'level'} || $membergrp{$user} eq '')) { $membergrp{$user} = $_; }
					++$permissions{$_}{'count'};
				}
			}
	}

	@grpsposts = sort{$a <=> $b} @grpsposts;

	# Check if user has post group permissions ...
	if($username ne 'Guest') {
		foreach(@grpsposts) {
			($num,$memgrp) = split(/\|/,$_);
			if($memberid{$username}{'posts'} >= $num) {
				$members{$memgrp,$username} = 1;
				if(($membergrp{$username} eq '' || $tmaxnum) && $tmaxnum < $num) { $tmaxnum = $num; $membergrp{$username} = $memgrp; }
			}
		}
	}

	LMGS();
}

sub SaveMemberID {
	my($userid) = $_[0];
	my($iddata,$item,$itemvalue,@printuser,$hasdat,$failsafe,$savememberid,@memitems,@memvals);

	return(0) if($userid eq '');

	if($userid eq 'Guest') { return(); }
	if($userid ne 'new') { GetMemberID($userid); } # Make sure user is in memory

	while(($item,$itemvalue) = each(%addtoID)) {
		return(-1) if($item eq 'sn' && $itemvalue eq '');

		push(@memitems,$item);
		push(@memvals,$itemvalue);
	}

	if($userid eq 'new') {
		$savememberid = SQL->new('members');
		$savememberid->into(@memitems);
		$newuserid = $savememberid->insert(@memvals);
	} else {
		$savememberid = SQL->new('members');
		$savememberid->where('userid');
		$savememberid->set(@memitems);
		$savememberid->update(@memvals,$userid);
	}

	%addtoID  = (); # Ah, this does need to be cleared ...
	%changeid = (); # Clear this too!
}

sub GetMemberID {
	my($userid,$override) = @_;
	my($iddata,$coloruser,$getuserid);

	if($userattempted{$userid} || $userid eq '' || $userid !~ s~^(\.?\d+\.?\d*)\Z~$1~g) { return(1); }

	if($memberid{$userid}{'sn'} eq '' && !$sqlmemberloaded{$userid}) {
		$getuserid = SQL->new('members','userid');
		$getuserid->where('userid');
		%memberid = (%memberid, $getuserid->select($userid));
	}

	$userattempted{$userid} = 1;

	if($override ne 'force' && (($hiddenmail == 2 && $username eq 'Guest') || ($hiddenmail == 1))) { $memberid{$userid}{'hidemail'} = 1; }

	if($override ne 'force') { $memberid{$userid}{'sn'} = CensorList($memberid{$userid}{'sn'}); }

	if($membergrp{$userid} eq '') {
		foreach(@grpsposts) {
			($num,$memgrp) = split(/\|/,$_);
			if($memberid{$userid}{'posts'} >= $num) { $membergrp{$userid} = $memgrp; }
		}
	}

	$coloruser = $permissions{$membergrp{$userid}}{'color'} ? qq~ class="usercolors" style="color: $permissions{$membergrp{$userid}}{'color'}"~ : '';

	$userurl{$userid} = qq~<a href="$surl\lv-memberpanel/a-view/u-$userid/" rel="nofollow"$coloruser onclick="target='_parent';">$memberid{$userid}{'sn'}</a>~;

	return(1);
}

sub FindUsername {
	my($findusername,$emailsearch,$usernameget) = @_;
	my($tmailsearch,$id,%sqltemp);

	if($findusername eq '') { $findusername = $emailsearch; }
	if($emailsearch eq '') { $emailsearch = $findusername; }

	$id = SQL->new('members');
	$id->where('sn||OR','email');
	%sqltemp = $id->select($findusername,$emailsearch);
	$id = $id->{_varval};

	if($sqltemp{$id}{'userid'} ne '') {
		GetMemberID($sqltemp{$id}{'userid'}) if(!$usernameget);
		return($sqltemp{$id}{'userid'});
	}

	return();
}

sub FindOldMemberName { # Tries to returns old member name of deleted users
	my($user) = $_[0];
	my($oldid,$olduser,$oldmembers);

	if($user =~ s/ \(Guest\)\Z//gis) { return(CensorList($user)); }

	if(!$oldlog) {
		CoreLoad('oldmembers',2);
		if(!$delcache) {
			$oldmembers = SQL->new('oldnames','id');
			%oldmember = $oldmembers->select();
			$cache = Cache->new();
			$cache->hash('oldmember',%oldmember);
			$cache->save('oldmembers',1440);
		}
		$oldlog = 1;
	}

	if($oldmember{$user} ne '') { return(CensorList($oldmember{$user}{'name'})); }
		else { return(CensorList($user)); }
}
1;