#######################
# Cache for E-Blah    #
#######################

package Cache;

sub new {
    my($class) = @_;
    my $self = {
		_data => undef,
		_array => undef,
		_hashes => undef
    };

	@{"_$self->{_varval}"} = ();
    bless($self,$class);
    return($self);
}

sub save {
	my($self,$cachename,$timeout) = @_;
	my($savedata,$value1,$value2,$key1,$key2,$hname,$array);

	if(@{"_hashes$self"}) {
		foreach $hname (@{"_hashes$self"}) {
			while(($key1,$value1) = each(%{"_$self_$hname"})) {
				if(%{$value1}) {
					while(($key2,$value2) = each(%{$value1})) {
						next if($value2 eq '');
						$savedata .= "\$$hname\{'$key1'\}\{'$key2'\} = '".badslash($value2)."';\n";
					}
				} else {
					$savedata .= "\$$hname\{'$key1'\} = '".badslash($value1)."';\n";
				}
			}
			%{"_$self_$hname"} = ();
		}
		@{"_hashes$self"} = ();
	}

	if(@{"_arrays$self"}) {
		foreach $array (@{"_arrays$self"}) {
			$savedata .= "\@$array = (";
			foreach $data (@{"_$self_$array"}) {
				$savedata .= "'".badslash($data)."',";
			}
			$savedata =~ s/,\Z//g;
			$savedata .= ");\n";
			@{"_$self_$array"} = ();
		}
		@{"_arrays$self"} = ();
	}

	if(@{"_vars_$self"}) {
		foreach $vars (@{"_vars_$self"}) {
			$savedata .= "\$$vars = '".badslash(${"_$self_$vars"})."';\n";
			${"_$self_$vars"} = '';
		}
		@{"_vars_$self"} = ();
	}

	$timeout = ($timeout*60)+time;

	main::fopen(CACHE,">$main::forumcache/$cachename.pl");
	print main::CACHE <<"EOT";
\$delcache = 1;
if($timeout < time) { \$delcache = 0; return(-1); }
$savedata
1;
EOT
	main::fclose(CACHE);
}

sub badslash {
	my($x) = $_[0];
	$x =~ s/\'/\\'/g;
	return($x);
}

sub array {
	my($self,$arrayname,@array) = @_;

	push(@{"_arrays$self"},$arrayname);

	@{"_$self_$arrayname"} = @array;
}

sub hash {
	my($self,$hashname,%hash) = @_;

	%{"_$self_$hashname"} = %hash;
	push(@{"_hashes$self"},$hashname);
}

sub variable {
	my($self,$varname,$var) = @_;

	push(@{"_vars_$self"},$varname);

	${"_$self_$varname"} = $var;
}

sub delete {
	my($self,$delete) = @_;

	unlink("$main::forumcache/$delete.pl");
}
1;