#!/usr/bin/perl

############################################################
# E-Blah Bulletin Board Systems              9 August 2008 #
############################################################
# Software Version: E-Blah SQL                             #
# Project started : December 2001/Febuary 2007 by Justin   #
# Distributed by  : http://www.eblah.com                   #
# License         : http://www.eblah.com/license.php       #
############################################################
# This program is free software; you can redistribute it   #
# and/or modify it under the terms of the GNU General      #
# Public License as published by the Free Software         #
# Foundation; version 2 of the License.                    #
# This program is distributed in the hope that it will be  #
# useful, but WITHOUT ANY WARRANTY; without even the       #
# implied warranty of MERCHANTABILITY or FITNESS FOR A     #
# PARTICULAR PURPOSE.  See the GNU General Public License  #
# for more details.                                        #
############################################################
# Copyright (c) 2001 - 2008 E-Blah.                        #
############################################################

# What is the directory that Settings.pl is located in?
$root = ".";

# This should be the only line you need to edit for Avatars, uploads, and templates directories
$bdocsdir2 = "$ENV{'DOCUMENT_ROOT'}/blahdocs";

####################################################
# DO NOT MODIFY ANYTHING BELOW THIS LINE!          #
####################################################
$eversion = 'Beta 4';

$code       = "$root/Code";
$prefs      = "$root/Prefs";
$languages  = "$root/Languages";
$modsdir    = "$root/Mods";
$images     = "/blahdocs/images";
$buttons    = "/blahdocs/buttons";
$simages    = "/blahdocs/Smilies";
$avsurl     = "/blahdocs/Avatars";
$uploadurl  = "/blahdocs/uploads";
$templatesu = "/blahdocs/template";
$bdocsdir   = "/blahdocs";
$avdir      = "$bdocsdir2/Avatars";
$uploaddir  = "$bdocsdir2/uploads";
$templates  = "$bdocsdir2/template";

# HOLY, HOLY, HOLY IS THE LORD GOD ALMIGHTY!

use DBI;

use CGI::Carp fatalsToBrowser;
$version = 3;

UFS();
DatabaseCreate() if($URL{'page'} eq 'database');
Install() if($URL{'page'} eq 'install');
Finish() if($URL{'page'} eq 'finish');
Upgrade() if($URL{'page'} eq 'upgrade');
Main();

sub header {
	print "Content-type: text/html\n\n";

	print <<"EOT";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>

<title>$title - E-Blah Installation</title>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />

<link rel="stylesheet" type="text/css" href="/blahdocs/template/X2/template.css" />

<!--[if lt IE 7]>
<script defer type="text/javascript" src="/blahdocs/pngfix.js"></script>
<![endif]-->

<style type="text/css">
.badinstall {
	background-color: #FFF5F5;
	padding         : 5px;
	border          : 1px solid #293B2A;
	color           : #FF2723;
	line-height     : 1.7;
}

.badcolor { color: #FF2723; }

.goodinstall {
	background-color: #DEE8DF;
	padding         : 5px;
	border          : 1px solid #293B2A;
	color           : #293B2A;
	line-height     : 1.7;
}

.large {
	font-size: 14px;
}

.blockquote {
	margin      : 20px;
	margin-left : 40px;
	margin-right: 40px;
	text-align  : justify;
}

.installer {
	font-size    : 18px;
	font-weight  : bold;
	padding-right: 20px;
	padding-left : 20px;
}
</style>

</head>

<body>
<div id="container">
	<div id="user-info">
		Install version $version
	</div>
	<div id="title">
		$title
	</div>

	<div id="menu-container">
		<table cellpadding="10" cellspacing="0"><tr><td>E-Blah SQL <strong>$eversion</strong> Installer</td></tr></table>
	</div>

	<div id="content">
		<table width="100%" cellpadding="0" cellspacing="0"><tr><td>
EOT
}

sub footer {
	print <<"EOT";
		</td></tr></table>
	</div>
</div>

<div id="copyright" class="smalltext">
	<span style="float: left">Copyright 2007 E-Blah</span>
	<span style="float: right"><a href="http://validator.w3.org/check/referer" onclick="target='_blank';"><img src="/blahdocs/images/xhtml.png" alt="Valid XHTML" title="Valid XHTML" /></a> <a href="http://jigsaw.w3.org/css-validator/check/referer" onclick="target='_blank';"><img src="/blahdocs/images/css.png" alt="Valid CSS" title="Valid CSS" /></a></span><br /><br />
</div>
</body>
</html>
EOT
	exit;
}

sub Main {
	$title = "E-Blah Install";
	header();

	@driver_names = DBI->available_drivers();

	foreach(@driver_names) {
		if($_ eq 'mysql') { $sqlyay = 1; }
		elsif($_ eq 'SQLite') { $sqlyay = 1; }
	}

	$nodir .= "<li><span style=\"width: 150px\">Prefs</span><b> Currently set to:</b> $prefs</li>" if(!-e("$prefs"));
	$nodir .= "<li><span style=\"width: 150px\">Languages</span><b> Currently set to:</b> $languages</li>" if(!-e("$languages"));
	$nodir .= "<li><span style=\"width: 150px\">Avatars</span><b> Currently set to:</b> $avdir</li>" if(!-e("$avdir"));
	$nodir .= "<li><span style=\"width: 150px\">uploads</span><b> Currently set to:</b> $uploaddir</li>" if(!-e("$uploaddir"));
	$nodir .= "<li><span style=\"width: 150px\">template</span><b> Currently set to:</b> $templates</li>" if(!-e("$templates"));

	if($nodir) {
		$nodir =~ s/, \Z//g;
		$nodir = <<"EOT";
 <div class="badinstall">
  <strong class="large">WARNING!</strong><br />
  Your forum <i>may</i> not work properly if you continue. Setup recommends editing the path to directories in Settings.pl and then refreshing this page until this message disappears. There was a problem verifying that the following directories exist:<br />
  <div class="blockquote">
   $nodir
  </div>
  The following may help you figure out what your paths are:
  <div class="blockquote">
   <strong>Document Root:</strong> $ENV{'DOCUMENT_ROOT'}<br />
   <strong>Script name:</strong> $0
  </div>
  Please note that not <i>all</i> server report the above information correctly.<br /><br />
  <strong>For the quickest support on the <a href="http://www.eblah.com/forum/">E-Blah Support Forum</a>, PLEASE copy and past <i>everything</i> in this red box.</strong>
 </div>
EOT
	} else {
			$nodir = <<"EOT";
 <div class="goodinstall">
  <strong class="large">Directory Success!</strong><br />
  Setup has verified that all the directories appear to exist on the server (they may not be writeable though). Setup will <i>attempt</i> to chmod these directories before continuing (to make them writeable). However, it is recommended that you chmod the directories and files as shown in the install documentation before continuing. Again, setup will <i>attempt</i> to chmod these directories for you; <strong>however</strong>, there is no guarantee that it will work.
 </div>
EOT
		}

	print <<"EOT";
<table cellpadding="8" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win">Welcome, you are at the point in the install where you can see if you can actually run E-Blah SQL or not. If you cannot install E-Blah, you'll have errors below.</td>
 </tr><tr>
  <td class="win2" style="padding: 10px; line-height: 2">
  $nodir<br />
EOT
	if($sqlyay) {
		print <<"EOT";
You may install E-Blah.  You have the following DBI modules installed that will work with E-Blah:<br />
<ul>
EOT
		foreach(@driver_names) {
			if($_ eq 'mysql') { print '<li>MySQL</li>'; }
			if($_ eq 'SQLite') { print '<li>SQLite</li>'; }
		}

		if(-s("$root/Settings.pl") > 0) { $upgrade = qq~<br /><a href="?page-upgrade/">Beta to Current Upgrade &raquo;</a>~; }

		print <<"EOT";
</ul>
Your DBI version is <strong>$DBI::VERSION</strong>; please make a note of it for support inquiries!<br /><br />
<div style="font-size: 18px; font-weight: bold; background: #DDD; padding: 10px; border: 1px solid #000;"><a href="?page-database/">New Installation &raquo;</a>$upgrade</div>
EOT
	}
	print <<"EOT";
  </td>
 </tr>
</table>
EOT

	footer();
}

sub DatabaseCreate {
	$title = "E-Blah Install";
	header();

	@driver_names = DBI->available_drivers();

	print <<"EOT";
<script type="text/javascript">
<!-- //
function showhidesql(valy) {
	if(valy == 'mysql') { document.getElementById('mysqlset').style.display = ''; }
		else { document.getElementById('mysqlset').style.display = 'none'; }
}
// -->
</script>
<table cellpadding="8" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win">Please enter your database information below. If you are using SQLite, you only need to select it and then continue to the next step.</td>
 </tr><tr>
  <td class="win2" style="padding: 10px">
  <form action="?page-install/" method="post">
   <table cellpadding="8" cellspacing="0" class="innertable">
    <tr>
	 <td>Database type:</td>
	 <td><select name="databasetype" onchange="showhidesql(this.value)">
EOT
	foreach(@driver_names) {
		if($_ eq 'mysql') { print '<option value="mysql" selected="selected">MySQL</option>'; }
		if($_ eq 'SQLite') { print '<option value="SQLite">SQLite</option>'; }
	}
	print <<"EOT";
	 </select></td>
	</tr>
   </table>
   <table cellpadding="8" cellspacing="0" width="100%" class="innertable" id="mysqlset">
    <tr>
     <td colspan="2" class="catbg">MySQL Setup</td>
    </tr><tr>
	 <td width="1%"><input type="text" name="server" value="localhost" /></td>
	 <td>Database server</td>
	</tr><tr>
	 <td><input type="text" name="database" value="" /></td>
	 <td>Database</td>
	</tr><tr>
	 <td><input type="text" name="prefix" value="eblah_" /></td>
	 <td>Table prefix</td>
	</tr><tr>
	 <td><input type="text" name="username" value="" /></td>
	 <td>Database User</td>
	</tr><tr>
	 <td><input type="password" name="password" value="" /></td>
	 <td>Database Password</td>
	</tr>
   </table>
   <table cellpadding="8" cellspacing="0" width="100%" class="innertable">
    <tr>
     <td colspan="2" class="catbg">Continue Setup</td>
    </tr><tr>
	 <td colspan="2"><input type="submit" class="installer" name="new" value="New Install" /> <input type="submit" class="installer" name="convert" value="E-Blah 10.2.5 Conversion" /></td>
	</tr>
   </table>
   </form>
  </td>
 </tr>
</table>
EOT

	footer();
}

sub Install {
	Convert() if($FORM{'convert'} ne '');
	$title = "New Installation";
	header();

	print <<"EOT";
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win">Please enter your database information below.</td>
 </tr><tr>
  <td class="win2" style="padding: 10px">
  <form action="?page-finish/" method="post">
   <table cellpadding="8" cellspacing="0" class="innertable">
    <tr>
	 <td>Your forum screenname:</td>
	 <td><input type="text" name="screenname" value="Administrator" size="30" class="textinput"></td>
	</tr><tr>
	 <td>Your forum password:</td>
	 <td><input type="password" name="pw" value="admin" maxlength="8" class="textinput"></td>
	</tr><tr>
	 <td>Your forum e-mail address:</td>
	 <td><input type="text" name="email" value="admin\@mysite.com" size="30" class="textinput"></td>
	</tr><tr>
	 <td>Cookie prefix:</td>
	 <td><input type="text" name="cookpre" value="eblah" class="textinput" size="10"></td>
	</tr><tr>
	 <td>Forum name:</td>
	 <td><input type="text" name="forumname" value="$ENV{'SERVER_NAME'} Forum" class="textinput" size="40"></td>
	</tr><tr>
	 <td>Forum URL:</td>
	 <td><input type="text" name="realurl" value="http://$ENV{'SERVER_NAME'}$path" class="textinput" size="40"></td>
	</tr><tr>
	 <td colspan="2"><input type="hidden" name="databasetype" value="$FORM{'databasetype'}" /><input type="hidden" name="server" value="$FORM{'server'}" /><input type="hidden" name="database" value="$FORM{'database'}" /><input type="hidden" name="prefix" value="$FORM{'prefix'}" /><input type="hidden" name="username" value="$FORM{'username'}" /><input type="hidden" name="password" value="$FORM{'password'}" /><input type="submit" class="installer" value="Finish Install" /></td>
	</tr>
   </table>
   </form>
  </td>
 </tr>
</table>
EOT

	footer();
	exit;
}

sub Convert {
	$title = "Convert to SQL";
	header();

	print <<"EOT";
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win">Please enter your old forum information below.<br /><strong>Be sure to convert all passwords to MD5 before converting your forum.</strong></td>
 </tr><tr>
  <td class="win2" style="padding: 10px">
  <form action="?page-finish/" method="post">
   <table cellpadding="8" cellspacing="0" class="innertable">
    <tr>
	 <td>Boards directory:</td>
	 <td><input type="text" name="boards" value="./Boards" /></td>
	</tr><tr>
	 <td>Messages directory:</td>
	 <td><input type="text" name="messages" value="./Messages" /></td>
	</tr><tr>
	 <td>Members directory:</td>
	 <td><input type="text" name="members" value="./Members" /></td>
	</tr><tr>
	 <td>Cookie prefix:</td>
	 <td><input type="text" name="cookpre" value="eblah" class="textinput" size="10"></td>
	</tr><tr>
	 <td>Forum name:</td>
	 <td><input type="text" name="forumname" value="$ENV{'SERVER_NAME'} Forum" class="textinput" size="40"></td>
	</tr><tr>
	 <td>Forum URL:</td>
	 <td><input type="text" name="realurl" value="http://$ENV{'SERVER_NAME'}$path" class="textinput" size="40"></td>
	</tr><tr>
	 <td colspan="2"><input type="hidden" name="databasetype" value="$FORM{'databasetype'}" /><input type="hidden" name="server" value="$FORM{'server'}" /><input type="hidden" name="database" value="$FORM{'database'}" /><input type="hidden" name="prefix" value="$FORM{'prefix'}" /><input type="hidden" name="username" value="$FORM{'username'}" /><input type="hidden" name="password" value="$FORM{'password'}" /><input type="submit" class="installer" value="Finish Install" /></td>
	</tr>
   </table><br />
   <div class="badinstall"><strong class="large">Warning</strong><br />When you click "Finish", Setup will complete several actions. This may take several minutes. Do not refresh or leave the page.<br />Also, be sure to <strong>convert all passwords to MD5 before converting your forum</strong>.</div>
   </form>
  </td>
 </tr>
</table>
EOT

	footer();
	exit;
}

sub CreateUser {
	print "Content-type: text/html\n\n";
	print "Done.<br />" if($URL{'section'} == 3);
	exit if($URL{'section'} == 3);

	require Digest::MD5;
	import Digest::MD5 qw(md5_hex);
	$crypted = md5_hex($userpassword);

	$sql = SQL->new('members');
	$sql->into('sn','password','email','registered','md5upgrade');
	$sql->insert($regto,$crypted,$eadmin,time,1);

	$sql = SQL->new('settings');
	$sql->into('variable','value');

	$sql->insert('membertotal',1);
	$sql->insert('lastmember',1);
	$sql->insert('maxactive',0);
	$sql->insert('maxactivetime',time);

	$sql = SQL->new();
	$sql->trans(qq~INSERT INTO ${forumprefix}boards VALUES (1, 1, 0, 'Chit chat about anything.', NULL, 'General Discussion', 'guest,validating,member', 'member,guest,validating', 'guest,validating,member', NULL, NULL, NULL, 'guest,member,validating', NULL, 'guest,member,validating', '', '', 'validating,guest,member', 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL)~) or $error = 1;

	$sql = SQL->new();
	$sql->trans(qq~INSERT INTO ${forumprefix}categories VALUES (1, 0, 0, 'General Category', 'member,validating,guest', '')~) or $error = 1;

	print "Created user account.<br />";
	exit;
}

sub Finish {
	if($FORM{'databasetype'} ne '') {
		open(SETTINGS,">$root/Settings.pl");
		$savesettings = <<"EOT";
\$forumdbdb = "$FORM{'database'}";
\$forumdbserver = "$FORM{'server'}";
\$forumdbuser = "$FORM{'username'}";
\$forumdbpass = "$FORM{'password'}";
\$forumprefix = "$FORM{'prefix'}";
\$membersdir = "$FORM{'members'}";
\$boardsdir = "$FORM{'boards'}";
\$messagesdir = "$FORM{'messages'}";
\$userpassword = "$FORM{'pw'}";
\$databasetype = "$FORM{'databasetype'}";

####################################################
# E-Blah Bulliten Board Systems               2009 #
####################################################
# This file was created by the setup.              #
#                                                  #
# YOU SHOULD NEVER EDIT THIS FILE BY HAND          #
####################################################

\$bversion = 2;      # POST-SETUP Version

####### Directories Sets #######
\$root = "$root";
\$code = "$code";
\$prefs = "$prefs";
\$images = "$images";
\$buttons = "$buttons";
\$simages = "$simages";
\$avsurl = "$avsurl";
\$avdir = "$avdir";
\$realurl = "$FORM{'realurl'}";
\$bdocsdir = "$bdocsdir";
\$languages = "$languages";
\$templates = "$templates";
\$templatesu = "$templatesu";
\$modsdir = "$modsdir";
\$bdocsdir2 = "$bdocsdir2";
\$regto = qq*$FORM{'screenname'}*;
\$eadmin = q*$FORM{'email'}*;
\$cookpre = qq*$FORM{'cookpre'}*;
\$mailuse = 1;
\$smaill = "/usr/sbin/sendmail";
\$emailsig = q*This e-mail was sent via E-Blah.*;
\$maintancer = qq~This board is being upgraded.~;
\$uploaddir = "$uploaddir";
\$uploadurl = "$uploadurl";
\$maxsize = "1";
\$maxsize2 = ".25";
\$upbc = 1;
\$noguestp = 1;
\$al = 1;
\$whereis = 1;
\$showmove = 1;
\$apic = 1;
\$hmail = 1;
\$slpoller = 1;
\$BCSmile = 1;
\$BCLoad = 1;
\$showreg = 1;
\$maxsig = "500";
\$maxmess = 15;
\$maxdis = 30;
\$mbname = q*$FORM{'forumname'}*;
\$picheight = "100";
\$picwidth = "100";
\$btod = 1;
\$amar = 1;
\$sauser = 1;
\$mmpp = 25;
\$iptimeout = 5;
\$vhtdmax = 50;
\$htdmax = 25;
\$totalpp = 10;
\$showdes = 1;
\$showtheme = 1;
\$sview = 1;
\$showactive = 1;
\$logactive = 1;
\$reversesum = 1;
\$languagep = "English";
\$nocomma = ',';
\$polltop = 1;
\$pollops = "7";
\$quickreply = 1;
\$gmaxsmils = 200;
\$maxmesslth = 50000;
\$maxsumc = "40";
\$upevents = 7;
\$disablesn = 1;
\$disabledel = 1;
\$eclick = 0;
\$uextlog = 0;
\$kelog = 0;
\$logip = 0;
\$logcnt = "60";
\$logdays = 365;
\$activeuserslog = 15;
\$newsshow = 5;
\$newslength = 200;
\$ensids = 0;
\$menutext = 2;
\$indextext = 0;
\$posttext = 0;
\$gdisable = 1;
\$yabbconver = 1;
\$encryption = 2;
\$md5upgrade = 1;
EOT
		$savesettings =~ s~\\~/~sig; # Get rid of {x}:\ with Win32 systems
		print SETTINGS $savesettings;
		close(SETTINGS);

		require("$root/Settings.pl");
	} else {
		require("$root/Settings.pl");
		require("$root/EBlah/$databasetype.pm");
		SQL->sqlconnect();
	}

	if($membersdir ne '') {
		CreateTables() if($URL{'section'} == 1);
		ConvertMembers() if($URL{'section'} == 2);
		ConvertMessages() if($URL{'section'} == 3);
	} else {
		CreateTables() if($URL{'section'} == 1);
		CreateUser() if($URL{'section'} == 2);
		CreateUser() if($URL{'section'} == 3);
	}

	$title = "Finish Install";
	header();

	print <<"EOT";
<script language="JavaScript" type="text/javascript">
<!-- <![CDATA[
var req;
function EditMessage(url,messageid,levelnum2) {
	EditMessage2(url);

	function EditMessage2(url,messageid,levelnum2) {
		req = false;
		if(window.XMLHttpRequest) { // Non IE browsers
			try { req = new XMLHttpRequest(encoding="utf-8"); }
			catch(e) { req = false; }
		} else if(window.ActiveXObject) { // IE
			try { req = new ActiveXObject("Msxml2.XMLHTTP"); }
			catch(e) {
				try { req = new ActiveXObject("Microsoft.XMLHTTP"); }
				catch(e) { req = false; }
			}
		}

		if(req) {
			req.onreadystatechange = processReqChange;
			req.open("POST", url, true); // Use POST so we don't get CACHED items!
			req.send('TEMP');
		} else { alert('Cannot upgrade, please refresh.'); }
	}

	function processReqChange() {
		if(req.readyState != 4) { document.getElementById(messageid).innerHTML = '<img src="$images/converting.gif" style="float: left; padding-right: 5px;" alt="" /> Please wait ...'; }
		if(req.readyState == 4) {
			if (req.status == 200) {
				document.getElementById(messageid).innerHTML = req.responseText;

				if(levelnum2 == 4) {
					document.getElementById('conversiondot').style.display = "none";
					document.getElementById('convertedid').style.display = "";
				}
				if(levelnum2 < 4) { Conversioooon(levelnum2); }
			} else {
				document.getElementById('conversiondot').style.display = "none";
				document.getElementById('conversionstats').style.display = "none";
				document.getElementById('conversionerror').style.display = "";
			}
		}
	}
}

// ]]> -->
</script>

<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win">Your forum is now being installed or converted ...</td>
 </tr><tr>
  <td class="catbg">Installation Status</td>
 </tr><tr>
  <td class="win2" style="padding: 10px">
	<div id="conversionstats">
	 <div class="win2 header">
	  Current Forum Conversion Status ...
	 </div>
	 <div class="blockquote">
	  <span id="one"></span>
	  <span id="two"></span>
	  <span id="three"></span>
	  <span id="four"></span>
	  <span id="five"></span>
	 </div>
	</div>
  </td>
 </tr><tr>
  <td class="catbg">Current Status</td>
 </tr><tr>
  <td class="win">
  <div id="conversiondot">
	 <div class="win2 header">
	  Please wait ...
	 </div>
	 <div class="blockquote">
	  Your forum is being installed, this could take a few minutes ...<br /><br /><strong>DO NOT REFRESH OR LEAVE THIS PAGE UNTIL INSTALL IS COMPLETE</strong>
	 </div>
	</div>
	
	<div style="display: none" id="convertedid">
	 <div class="win2 header">
	  Installation Finished ...
	 </div>
	 <div class="blockquote" id="setup-options">
	  This forum has been installed successfully!<br /><br /><strong><a href="Blah.pl">Go to your forum.</a></strong>
	 </div>
	</div>
	
	<div style="display: none" id="conversionerror">
	 <div class="win2 header">
	  <img src="$images/warning_sm.png" style="float: left; padding-right: 5px;" alt="" /> Fatal Error
	 </div>
	 <div class="blockquote">
	  Your forum cannot be upgraded at this time.</strong>
	 </div>
	</div>
  </td>
 </tr>
</table>

<script language="JavaScript" type="text/javascript">
<!-- <![CDATA[

function Conversioooon(levelnum) {
	if(levelnum == 1) { therid = 'one'; }
	if(levelnum == 2) { therid = 'two'; }
	if(levelnum == 3) { therid = 'three'; }
	levelnum2 = 1 + (levelnum*1);
	EditMessage('?page-finish/section-'+ levelnum + '/',therid,levelnum2);
}
Conversioooon('1');

// ]]> -->
</script>
EOT

	footer();
	exit;
}

sub CreateTables {
	print "Content-type: text/html\n\n";

	if($databasetype eq 'SQLite') {
		if(-s("$root/database.db") <= 0) { print "The SQLite database cannot be found. Was it placed in the same directory Blah.pl was?<br />"; }
			else { print "Connected to SQLite database successfully.<br />"; }
		exit;
	}

	$tables = <<"EOT";
CREATE TABLE `activelist` (
  `user` varchar(25) NOT NULL,
  `guest` tinyint(1) NOT NULL DEFAULT '0',
  `time` int(11) NOT NULL,
  `view` varchar(10) DEFAULT NULL,
  `boardid` int(10) DEFAULT NULL,
  `messageid` int(10) DEFAULT NULL,
  KEY `time` (`time`)
) ENGINE=MYISAM;

CREATE TABLE `adminlog` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `userid` int(10) NOT NULL,
  `time` int(11) NOT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `action` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `badnames` (
  `name` varchar(50) NOT NULL,
  `search` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MYISAM;

CREATE TABLE `banlist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` varchar(50) NOT NULL,
  `timelimit` int(3) DEFAULT NULL,
  `dateadded` int(11) DEFAULT NULL,
  `group` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `user` (`user`)
) ENGINE=MYISAM;

CREATE TABLE `banlog` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `userid` int(10) DEFAULT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `boards` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(10) NOT NULL,
  `order` int(10) NOT NULL,
  `description` text NOT NULL,
  `moderators` varchar(50) DEFAULT NULL,
  `name` varchar(150) NOT NULL,
  `start_perm` varchar(200) DEFAULT NULL,
  `reply_perm` varchar(200) DEFAULT NULL,
  `poll_perm` varchar(200) DEFAULT NULL,
  `password` varchar(30) DEFAULT NULL,
  `email` tinyint(1) DEFAULT NULL,
  `postcount` tinyint(1) DEFAULT NULL,
  `access_perm` varchar(200) DEFAULT NULL,
  `voting` tinyint(1) DEFAULT NULL,
  `upload_perm` varchar(200) DEFAULT NULL,
  `redirect` varchar(250) DEFAULT NULL,
  `image` varchar(250) DEFAULT NULL,
  `read_perm` varchar(200) DEFAULT NULL,
  `archived` tinyint(1) DEFAULT NULL,
  `posts` bigint(20) NOT NULL,
  `threads` bigint(20) NOT NULL,
  `hits` bigint(20) NOT NULL,
  `lastpost` varchar(15) DEFAULT NULL,
  `lastsubject` varchar(100) DEFAULT NULL,
  `lastuser` varchar(100) DEFAULT NULL,
  `lasticon` varchar(150) DEFAULT NULL,
  `lastmid` int(10) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `parent` (`parent`)
) ENGINE=MYISAM;

CREATE TABLE `categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(10) NOT NULL,
  `order` int(10) NOT NULL,
  `name` varchar(75) NOT NULL,
  `permissions` varchar(200) NOT NULL,
  `description` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `order` (`order`),
  FULLTEXT KEY `description` (`description`)
) ENGINE=MYISAM;

CREATE TABLE `censorlist` (
  `id` smallint(6) NOT NULL AUTO_INCREMENT,
  `word` varchar(50) NOT NULL,
  `replacement` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `clicklog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `time` int(11) NOT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `refer` varchar(200) DEFAULT NULL,
  `query` varchar(200) DEFAULT NULL,
  `agent` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=MYISAM;

CREATE TABLE `errorlog` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `message` mediumtext NOT NULL,
  `extrainfo` varchar(150) DEFAULT NULL,
  `time` int(11) NOT NULL,
  `userid` int(10) NOT NULL,
  `url` varchar(200) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `events` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `userid` mediumint(9) NOT NULL,
  `groups` varchar(150) DEFAULT NULL,
  `start` int(11) DEFAULT NULL,
  `end` int(11) DEFAULT NULL,
  `repeat` int(11) DEFAULT NULL,
  `xdays` int(11) DEFAULT NULL,
  `color` varchar(10) DEFAULT NULL,
  `title` varchar(50) NOT NULL,
  `desc` text NOT NULL,
  `time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`)
) ENGINE=MYISAM;

CREATE TABLE `extlog` (
  `id` int(11) NOT NULL,
  `clicks` int(11) DEFAULT NULL,
  `threads` int(11) DEFAULT NULL,
  `replies` int(11) DEFAULT NULL,
  `members` int(11) DEFAULT NULL,
  `attachments` int(11) DEFAULT NULL,
  `downloads` int(11) DEFAULT NULL,
  `spammers` int(11) DEFAULT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `loginlog` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `userid` mediumint(10) NOT NULL,
  `time` int(11) NOT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `type` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `memberlog` (
  `userid` varchar(20) NOT NULL,
  `board` varchar(25) NOT NULL,
  `visited` int(12) NOT NULL,
  KEY `userid` (`userid`)
) ENGINE=MYISAM;

CREATE TABLE `members` (
  `userid` int(11) NOT NULL AUTO_INCREMENT,
  `password` varchar(40) NOT NULL,
  `sn` varchar(50) NOT NULL,
  `adminverify` varchar(40) DEFAULT NULL,
  `email` varchar(100) NOT NULL,
  `posts` int(11) NOT NULL DEFAULT '0',
  `admintxt` varchar(50) DEFAULT NULL,
  `avatar` varchar(150) DEFAULT NULL,
  `personaltxt` varchar(75) DEFAULT NULL,
  `sex` tinyint(1) DEFAULT NULL,
  `icq` int(12) DEFAULT NULL,
  `aim` varchar(50) DEFAULT NULL,
  `msn` varchar(75) DEFAULT NULL,
  `skype` varchar(50) DEFAULT NULL,
  `sig` text,
  `hidemail` tinyint(1) DEFAULT NULL,
  `registered` varchar(20) NOT NULL,
  `dob` varchar(15) DEFAULT NULL,
  `dateformat` char(3) DEFAULT NULL,
  `hideonline` tinyint(1) DEFAULT NULL,
  `sitename` varchar(50) DEFAULT NULL,
  `siteurl` varchar(150) DEFAULT NULL,
  `location` varchar(100) DEFAULT NULL,
  `timeformat` char(3) DEFAULT NULL,
  `status` varchar(15) DEFAULT NULL,
  `validation` varchar(20) DEFAULT NULL,
  `ml` tinyint(1) DEFAULT NULL,
  `theme` varchar(15) DEFAULT NULL,
  `yim` varchar(50) DEFAULT NULL,
  `lastactive` varchar(12) DEFAULT NULL,
  `hidesum` tinyint(1) DEFAULT NULL,
  `notify` tinyint(1) DEFAULT NULL,
  `dst` tinyint(1) DEFAULT NULL,
  `avatarupload` tinyint(1) DEFAULT NULL,
  `shownewonly` tinyint(1) DEFAULT NULL,
  `lng` varchar(15) DEFAULT NULL,
  `showsig` tinyint(1) DEFAULT NULL,
  `ownavatar` tinyint(1) DEFAULT NULL,
  `pmdisable` tinyint(1) DEFAULT NULL,
  `pmcnt` smallint(4) NOT NULL DEFAULT '0',
  `pmnew` smallint(4) NOT NULL DEFAULT '0',
  `censor` tinyint(1) DEFAULT NULL,
  `pmpopup` tinyint(1) DEFAULT NULL,
  `reputation` tinyint(4) DEFAULT NULL,
  `prep` smallint(4) DEFAULT NULL,
  `nrep` smallint(4) DEFAULT NULL,
  `timeonline` varchar(50) DEFAULT NULL,
  `md5upgrade` tinyint(1) DEFAULT NULL,
  `blockedusers` varchar(120) DEFAULT NULL,
  `rndsid` varchar(30) DEFAULT NULL,
  `avatarsize` varchar(10) DEFAULT NULL,
  `lastvisit` varchar(50) DEFAULT NULL,
  `lastpm` int(11) DEFAULT NULL,
  `timezone` tinyint(2) DEFAULT '0',
  `lastpost` varchar(15) DEFAULT NULL,
  `forgotpass` varchar(50) DEFAULT NULL,
  `rank` VARCHAR( 50 ) DEFAULT NULL,
  PRIMARY KEY (`userid`),
  UNIQUE KEY `sn` (`sn`),
  UNIQUE KEY `email` (`email`),
  KEY `posts` (`posts`),
  KEY `reputation` (`reputation`)
) ENGINE=MYISAM;

CREATE TABLE `messageicons` (
  `id` smallint(6) NOT NULL AUTO_INCREMENT,
  `group` varchar(50) DEFAULT NULL,
  `icon` varchar(50) NOT NULL,
  `name` varchar(50) NOT NULL,
  `membergroups` varchar(75) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `moderatorlog` (
  `action` tinyint(2) NOT NULL,
  `user` int(10) NOT NULL,
  `time` int(11) NOT NULL,
  `boardfrom` int(10) DEFAULT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `threadid` int(10) DEFAULT NULL,
  `boardid` int(10) DEFAULT NULL,
  KEY `action` (`action`,`user`)
) ENGINE=MYISAM;

CREATE TABLE `notify` (
  `userid` int(10) NOT NULL,
  `midbid` varchar(10) NOT NULL,
  `watch` int(1) DEFAULT NULL,
  `added` int(11) NOT NULL,
  KEY `userid` (`userid`)
) ENGINE=MYISAM;

CREATE TABLE `oldnames` (
  `id` int(10) NOT NULL,
  `name` varchar(50) NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MYISAM;

CREATE TABLE `pm` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `owner` int(10) NOT NULL,
  `folder` tinyint(2) NOT NULL,
  `title` varchar(50) NOT NULL,
  `from` int(10) NOT NULL,
  `to` int(10) NOT NULL,
  `message` text NOT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `senttime` int(11) NOT NULL,
  `smiley` tinyint(1) DEFAULT NULL,
  `new` tinyint(1) NOT NULL DEFAULT '1',
  `flag` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `folder` (`folder`,`flag`),
  KEY `owner` (`owner`)
) ENGINE=MYISAM;

CREATE TABLE `pmfolders` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `userid` int(10) NOT NULL,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`)
) ENGINE=MYISAM;

CREATE TABLE `pmprefs` (
  `userid` int(10) NOT NULL,
  `email` tinyint(1) DEFAULT '0',
  `outbox` tinyint(1) DEFAULT '0',
  `sent` tinyint(1) DEFAULT '0',
  `buddies` mediumtext,
  PRIMARY KEY (`userid`)
) ENGINE=MYISAM;

CREATE TABLE `polllog` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `threadid` mediumint(9) NOT NULL,
  `userid` mediumint(9) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `threadid` (`threadid`)
) ENGINE=MYISAM;

CREATE TABLE `polloptions` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `threadid` mediumint(9) NOT NULL,
  `name` mediumtext NOT NULL,
  `votes` mediumint(9) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `threadid` (`threadid`)
) ENGINE=MYISAM;

CREATE TABLE `posts` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `boardid` int(10) NOT NULL,
  `threadid` int(10) NOT NULL,
  `tuser` varchar(50) NOT NULL,
  `message` mediumtext NOT NULL,
  `ipaddress` varchar(15) NOT NULL,
  `email` varchar(250) NOT NULL,
  `posttime` varchar(15) NOT NULL,
  `smiley` tinyint(1) DEFAULT NULL,
  `attachment` varchar(250) DEFAULT NULL,
  `modify` mediumtext,
  PRIMARY KEY (`id`),
  KEY `threadid` (`threadid`),
  KEY `boardid` (`boardid`)
) ENGINE=MYISAM;

CREATE TABLE `ranks` (
  `id` varchar(15) NOT NULL,
  `name` varchar(50) NOT NULL,
  `color` varchar(10) DEFAULT NULL,
  `team` tinyint(1) DEFAULT NULL,
  `coverup` tinyint(1) DEFAULT NULL,
  `desc` text,
  `accepting` tinyint(1) DEFAULT NULL,
  `hidden` tinyint(1) DEFAULT NULL,
  `star` varchar(50) DEFAULT NULL,
  `starcount` tinyint(10) DEFAULT NULL,
  `pcount` varchar(6) DEFAULT NULL,
  `ip` tinyint(1) DEFAULT NULL,
  `moderate` tinyint(1) DEFAULT NULL,
  `sticky` tinyint(1) DEFAULT NULL,
  `modify` tinyint(1) DEFAULT NULL,
  `profile` tinyint(1) DEFAULT NULL,
  `cal` tinyint(1) DEFAULT NULL,
  `level` tinyint(1) DEFAULT NULL,
  `colorcodes` tinyint(1) DEFAULT NULL,
  `manager` text,
  `members` text,
  `waiting` text,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `replog` (
  `userid` mediumint(9) NOT NULL,
  `userfixed` mediumint(9) NOT NULL,
  `rep` tinyint(1) NOT NULL,
  `time` int(11) NOT NULL,
  KEY `userfixed` (`userfixed`),
  KEY `userid` (`userid`)
) ENGINE=MYISAM;

CREATE TABLE `smileys` (
  `smiley` varchar(15) NOT NULL,
  `url` varchar(50) NOT NULL,
  `pack` varchar(50) DEFAULT NULL
) ENGINE=MYISAM;

CREATE TABLE `settings` (
  `variable` varchar(15) NOT NULL,
  `value` varchar(25) NOT NULL DEFAULT '0',
  PRIMARY KEY (`variable`)
) ENGINE=MYISAM;

CREATE TABLE `themeslist` (
  `id` varchar(25) NOT NULL,
  `default` tinyint(4) DEFAULT NULL,
  `images` tinyint(4) DEFAULT NULL,
  `buttons` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MYISAM;

CREATE TABLE `topics` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `boardid` int(10) NOT NULL,
  `sticky` tinyint(1) NOT NULL DEFAULT '0',
  `creationtime` int(11) NOT NULL,
  `subject` varchar(50) NOT NULL,
  `startuser` varchar(50) NOT NULL,
  `replies` int(10) NOT NULL,
  `poll` tinyint(1) DEFAULT '0',
  `polltitle` varchar(50) DEFAULT NULL,
  `pollvotes` mediumint(9) DEFAULT '0',
  `pollmc` tinyint(1) DEFAULT '0',
  `pollend` smallint(6) DEFAULT NULL,
  `type` tinyint(1) DEFAULT '0',
  `icon` varchar(25) DEFAULT NULL,
  `lasttime` int(11) NOT NULL,
  `lastuser` varchar(50) NOT NULL,
  `views` int(10) DEFAULT '0',
  `moveid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `boardid` (`boardid`),
  KEY `sticky` (`sticky`),
  KEY `lasttime` (`lasttime`)
) ENGINE=MYISAM;

INSERT INTO `$forumprefix\lpmfolders` VALUES (1, 0, 'Inbox');

INSERT INTO `$forumprefix\lpmfolders` VALUES (2, 0, 'Sent Items');

INSERT INTO `$forumprefix\lpmfolders` VALUES (3, 0, 'Storage');

INSERT INTO `$forumprefix\lranks` VALUES ('Administrator', 'Administrators', 'red', 1, NULL, 'Administrators group', 0, NULL, 'stype1.gif', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, '', '1', '');

INSERT INTO `$forumprefix\lranks` VALUES ('Moderators', 'Moderator', NULL, NULL, NULL, '', 0, NULL, '', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '', '', '');

INSERT INTO `$forumprefix\lranks` VALUES ('1172626789', 'New Member', '', NULL, NULL, NULL, NULL, NULL, 'stype3.gif', 0, '0', NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL);

INSERT INTO `$forumprefix\lthemeslist` VALUES ('X2', 1, NULL, NULL);
EOT

	foreach(split(";\n",$tables)) {
		next if($_ eq '');
		last if($error);
		$_ =~ s/TABLE `/TABLE `$forumprefix/g;
		$sql = SQL->new();
		$sql->trans($_) or $error = 1;
	}

	$sql = SQL->new('messageicons');
	$sql->into('icon','name');
	$sql->insert('lamp.png','Lamp');
	$sql->insert('question.png','Question');
	$sql->insert('news.png','News');
	$sql->insert('thumbup.png','Thumbs Up');
	$sql->insert('thumbdown.png','Thumbs Down');
	$sql->insert('ban.png','X');
	$sql->insert('smiley.png','Smiley');
	$sql->insert('angry.png','Angry');
	$sql->insert('lol.png','Laughing Out Loud');
	$sql->insert('open_thread.png','Folder');
	$sql->insert('warning.png','Warning');

	if($error) {
		print "There was an error with creating tables.<br />";
		exit;
	}
	print "All tables created.<br />";

	exit;
}

sub UFS {
	my($query);
	@url = split(/\//,$ENV{'QUERY_STRING'});
	foreach (@url) {
		($action,$actiondo) = split(/-/,$_);
		$URL{$action} = $actiondo;
	}
	read(STDIN, my $temp, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/,$temp);

	foreach (@pairs) {
		($key,$content) = split(/=/,$_);
		$content =~ tr/+/ /;
		$content =~ s/%(..)/pack("c",hex($1))/ge;
		$key =~ tr/+/ /;
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		chomp($content);
		$FORM{$key} = $content;
	}
}

sub ConvertMembers {
	$membercount = 0;
	$latestmember = 0;

	open(MEMBERS,"$membersdir/List.txt");
	while($member = <MEMBERS>) {
		chomp $member;
		GetMemberID($member) || next;

		next if($idcache{$member});
		$idcache{$member} = 1;

		next if($emailcache{$memberid{$member}{'email'}});
		$emailcache{$memberid{$member}{'email'}} = 1;

		open(PMS,"$membersdir/$member.pm");
		while ($pms = <PMS>) {
			($folder,$time,$title,$sentby,$message,$ipaddy,$new,$t,$t,$flag,$smiley) = split(/\|/,$pms);
			$folder = 3 if($folder != 1 && $folder != 2 && $folder != 3);
			$sql = SQL->new('pm');
			$sql->into('folder','owner','title','from','to','message','ipaddress','senttime','smiley','new','flag');
			$sql->insert($folder,$member,$title,$sentby,$member,$message,$ipaddy,$time,$smiley,$new,$flag);
		}
		close(PMS);

		$memberid{$member}{'registered'} = $memberid{$member}{'registered'} || 1;

		$sql = SQL->new('members');
		$sql->into('userid','password','sn','email','posts','admintxt','avatar','personaltxt','sex','icq','aim','msn','skype','sig','hidemail','registered','dob','dateformat','hideonline','sitename','siteurl','location','timeformat','status','validation','ml','theme','yim','lastactive','hidesum','notify','dst','avatarupload','shownewonly','lng','showsig','ownavatar','pmdisable','censor','pmpopup','reputation','timeonline','md5upgrade','blockedusers','rndsid','avatarsize','lastvisit','timezone','lastpost');
		$sql->insert($member,$memberid{$member}{'password'},$memberid{$member}{'sn'},$memberid{$member}{'email'},$memberid{$member}{'posts'},$memberid{$member}{'admintxt'},$memberid{$member}{'avatar'},$memberid{$member}{'personaltxt'},$memberid{$member}{'sex'},$memberid{$member}{'icq'},$memberid{$member}{'aim'},$memberid{$member}{'msn'},$memberid{$member}{'skype'},$memberid{$member}{'sig'},$memberid{$member}{'hidemail'},$memberid{$member}{'registered'},$memberid{$member}{'dob'},$memberid{$member}{'dateformat'},$memberid{$member}{'hideonline'},$memberid{$member}{'sitename'},$memberid{$member}{'siteurl'},$memberid{$member}{'location'},$memberid{$member}{'timeformat'},$memberid{$member}{'status'},$memberid{$member}{'validation'},$memberid{$member}{'ml'},$memberid{$member}{'theme'},$memberid{$member}{'yim'},$memberid{$member}{'lastactive'},$memberid{$member}{'hidesum'},$memberid{$member}{'notify'},$memberid{$member}{'dst'},$memberid{$member}{'avatarupload'},$memberid{$member}{'shownewonly'},$memberid{$member}{'lng'},$memberid{$member}{'showsig'},$memberid{$member}{'ownavatar'},$memberid{$member}{'pmdisable'},$memberid{$member}{'censor'},$memberid{$member}{'pmpopup'},$memberid{$member}{'reputation'},$memberid{$member}{'timeonline'},$memberid{$member}{'md5upgrade'},$memberid{$member}{'blockedusers'},$memberid{$member}{'rndsid'},$memberid{$member}{'avatarsize'},$memberid{$member}{'lastvisit'},$memberid{$member}{'timezone'},$memberid{$member}{'lastpost'});

		if($memberid{$member}{'registered'} > $latestmember) { $latestmember2 = $member; $latestmember = $memberid{$member}{'registered'}; }

		++$membercount;
	}
	close(MEMBERS);

	$sql = SQL->new('settings');
	$sql->into('variable','value');

	$sql->insert('membertotal',$latestmember2);
	$sql->insert('lastmember',$membercount);
	$sql->insert('maxactive',0);
	$sql->insert('maxactivetime',time);

	print "Content-type: text/html\n\n";
	print "Members converted.<br />";
	exit;
}

sub ConvertMessages {
	$counter = 1;
	open(STICK,"$boardsdir/Stick.txt");
	while(<STICK>) {
		chomp $_;
		($t,$mid) = split(/\|/,$_);
		$sticky{$mid} = 1;
	}
	close(STICK);

	$catsn = 1;
	open(CATS,"$boardsdir/bdscats.db");
	while($cats = <CATS>) {
		chomp $cats;
		($name,$t,$access,$boards,$desc) = split(/\|/,$cats);
	
		$order = 0;
		foreach $brds (split('/',$boards)) {
			$boardorder{$brds} = $order;
			$boardparent{$brds} = $catsn;
			++$order;
		}
	
		$sql = SQL->new('categories');
		$sql->into('id','parent','order','name','permissions','description');
		$sql->insert($catsn,0,$catsn,$name,$access,$desc);
		++$catsn;
	}
	close(CATS);
	
	open(BOARDS,"$boardsdir/bdindex.db");
	while($boards = <BOARDS>) {
		chomp $boards;
		($bid,$description,$mods,$name,$startperm,$replyperm,$pollperm,$passyword,$bemail,$postcount,$allowperm,$voting,$uploadperm,$redir,$image,$readperm,$arch) = split('/',$boards);
	
		$lastpost = $lastsubject = $lastuser = $lasticon = $lastmid = '';
	
		$temp = 1;
		$pcount{$counter} = 0;
		$tcount{$counter} = 0;
		open(MESSAGES,"$boardsdir/$bid.msg");
		while($messages = <MESSAGES>) {
			chomp $messages;
			($mid,$messtitle,$posted,$date,$replies,$poll,$type,$micon,$date,$lastuser) = split(/\|/,$messages);
	
			if($temp) {
				$lastpost = $date;
				$lastsubject = $messtitle;
				$lastsubject =~ s/\//&#47;/g;
				$lastuser = $lastuser;
				$lasticon = $micon;
				$lastmid = $mid;
				$temp = 0;
			}
	
			open(MESSAGE,"$messagesdir/$mid.txt");
			while($message = <MESSAGE>) {
				chomp $message;
				($user,$message,$ipaddr,$email,$fdate,$nosmile,$t,$t,$afile,$modified) = split(/\|/,$message);
				push(@posts,"$fdate|$mid|$counter|$user|$message|$ipaddr|$email|$fdate|$nosmile|$afile|$modified");
				++$pcount{$counter};
			}
			close(MESSAGE);
	
			open(VIEWS,"$messagesdir/$mid.view");
			$view = <VIEWS>;
			close(VIEWS);
			chomp $view;
	
			push(@messages,"$date|$mid|$counter|$messtitle|$posted|$date|$replies|$poll|$type|$micon|$date|$lastuser|$sticky{$mid}|$view");
	
			++$tcount{$counter};
		}
		close(MESSAGES);
	
		# NEEDED:
		### $pcount,$tcount,$lastpost,$lastsubject,$lastuser,$lasticon,$lastmid ###
	
		$lastid{$counter} = $lastmid;
	
		open(HITS,"$messagesdir/$mid.view");
		$HITS = <HITS>;
		close(HITS);
		chomp $HITS;
	
		push(@boardsX,"$counter/$boardparent{$bid}/$boardorder{$bid}/$description/$mods/$name/$startperm/$replyperm/$pollperm/$passyword/$bemail/$postcount/$allowperm/$voting/$uploadperm/$redir/$image/$readperm/$arch/$pcount{$counter}/$tcount{$counter}/$HITS/$lastpost/$lastsubject/$lastuser/$lasticon");
	
		++$counter;
	}
	close(BOARDS);
	
	$tid = 1;
	@messages = sort {$a <=> $b} @messages;
	foreach $message (@messages) {
		($t,$mid,$boardid,$messtitle,$posted,$date,$replies,$poll,$type,$micon,$date,$lastuser,$sticky,$views) = split(/\|/,$message);
		$oldmid{$mid} = $tid;
	
		$sql = SQL->new('topics');
		$sql->into('id','boardid','sticky','creationtime','subject','startuser','replies','poll','type','icon','lasttime','lastuser','views');
		$sql->insert($tid,$boardid,$sticky,$mid,$messtitle,$posted,$replies,$poll,$type,$micon,$date,$lastuser,$views);
	
		++$tid;
	}
	
	#$fdate|$mid|$counter|$user|$message|$ipaddr|$email|$fdate|$nosmile|$afile|$modified
	@posts = sort {$a <=> $b} @posts;
	
	$pid = 1;
	foreach $posts (@posts) {
		($t,$mid,$boardid,$user,$message,$ipaddr,$email,$fdate,$nosmile,$afile,$modified) = split(/\|/,$posts);
	
		$sql = SQL->new('posts');
		$sql->into('id','boardid','threadid','tuser','message','ipaddress','email','posttime','smiley','attachment','modify');
		$sql->insert($pid,$boardid,$oldmid{$mid},$user,$message,$ipaddr,$email,$fdate,$nosmile,$afile,$modified);
	
		++$pid;
	}
	
	# Now time to do db stuff:
	foreach $temp (@boardsX) {
		($t1,$t2,$t3,$t4,$t5,$t6,$t7,$t8,$t9,$t10,$t11,$t12,$t13,$t14,$t15,$t16,$t17,$t18,$t19,$t20,$t21,$t22,$t23,$t24,$t25,$t26) = split(/\//,$temp);
	
		$sql = SQL->new('boards');
		$sql->into('id','parent','order','description','moderators','name','start_perm','reply_perm','poll_perm','password','email','postcount','access_perm','voting','upload_perm','redirect','image','read_perm','archived','posts','threads','hits','lastpost','lastsubject','lastuser','lasticon','lastmid');
		$sql->insert($t1,$t2,$t3,$t4,$t5,$t6,$t7,$t8,$t9,$t10,$t11,$t12,$t13,$t14,$t15,$t16,$t17,$t18,$t19,$t20,$t21,$t22,$t23,$t24,$t25,$t26,$oldmid{$lastid{$t1}});
	}

	print "Content-type: text/html\n\n";
	print "Messages converted.<br />";

	exit;
}

sub Upgrade {
	require("$root/Settings.pl");
	require("$root/EBlah/$databasetype.pm");
	SQL->sqlconnect();

	if($databasetype eq 'SQLite') { $forumprefix = ''; }

	# Add Rank column ...
	$sql = SQL->new('members');
	%gdata = $sql->select();

	$upg = 1;
	while(($data,$date) = each(%{$gdata{$sql->{_varval}}})) {
		$upg = 0 if($data eq 'rank');
	}

	$sql = SQL->new();
	$sql->trans("ALTER TABLE `$forumprefix\lmembers` ADD `rank` VARCHAR( 50 )") if($upg);

	# Convert statistics (Beta 3.5) to Settings table
	$sql = SQL->new();
	$sql->trans("SELECT * FROM `$forumprefix\lsettings` LIMIT 1",1) or $error = 1;

	if($error) {
		$sql = SQL->new();
		$sql->trans("CREATE TABLE `$forumprefix\lsettings` (`variable` varchar(15) NOT NULL,`value` varchar(25) NOT NULL DEFAULT '0', PRIMARY KEY (`variable`))");

		$getlist = SQL->new('stats');
		%stats = $getlist->select();
		$globalstats = $getlist->{_varval};

		$sql = SQL->new('settings');
		$sql->into('variable','value');

		$sql->insert('membertotal',$stats{$globalstats}{'membertotal'});
		$sql->insert('lastmember',$stats{$globalstats}{'lastmember'});
		$sql->insert('maxactive',$stats{$globalstats}{'maxactive'});
		$sql->insert('maxactivetime',$stats{$globalstats}{'maxactivetime'});
	}

	# Add Message icons ...
	$sql = SQL->new('messageicons');
	if($sql->count() == 0) {
		$sql = SQL->new('messageicons');
		$sql->into('icon','name');
		$sql->insert('lamp.png','Lamp');
		$sql->insert('question.png','Question');
		$sql->insert('news.png','News');
		$sql->insert('thumbup.png','Thumbs Up');
		$sql->insert('thumbdown.png','Thumbs Down');
		$sql->insert('ban.png','X');
		$sql->insert('smiley.png','Smiley');
		$sql->insert('angry.png','Angry');
		$sql->insert('lol.png','Laughing Out Loud');
		$sql->insert('open_thread.png','Folder');
		$sql->insert('warning.png','Warning');
	}

	$title = "Upgrade";
	header();
	print <<"EOT";
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win2" style="padding: 10px; font-size: 18px;">Your forum has been upgraded!</td>
 </tr>
</table>
EOT
	footer();
	exit;
}

sub GetMemberID {
	my($userid) = @_;

	open(GETMEMBERID,"$membersdir/$userid.dat") || return(0);
	while($iddata = <GETMEMBERID>) {
		chomp $iddata;
		$iddata =~ /^(.+?) = \|(.*?)\|\Z/g;
		if($2 eq '') { next; }
		$memberid{$userid}{$1} = $2;
	}
	close(GETMEMBERID);
}

sub error {
	$title = "Install Error";
	header();
	print "$_[0]";
	footer();
	exit;
}
1;